<#
.Synopsis
		Autor     : Tiggerwaeller mit ChatGPT Unterstzung
		erstellt  : 24.04.2023
		gendert  : 

		Routine zum erstellen der Speedtest Ergebnisse mit der ookla-speedtest-1.2.0-win64
.DESCRIPTION
		Der PS Script Speedtest_chatgpt.ps1 erstellt eine .csv Datei, die bei nicht vorhanden
		erstellt wird und den CSV Header darin ausgibt.
		$header = '"date","time","server name","server id","latency","jitter","packetloss","download","upload","download bytes","upload bytes","share url"'
		 
.EXAMPLE
			Alle Variablen werden explizit gesetzt, der Interval der Abfrage ist auf 180 sekunden/3 Minuten gesetzt
			und kann an die eigenen Bedrfnisse angepat werden.
			
			Man knnte auch noch die Abfrage der Liste.txt mit einbauen, das kann man ja noch machen, ich 
			finde aber das man die alte mit der neuen Liste manuell vergleichen sollte und die -L Ausgabe 
			mit Liste_01.txt ausgibt und beide Dateien vergleicht und dann entscheidet ob es nderungen in
			der Serverliste gibt oder nicht.
#>
# Set the variables
$programPath = "D:\speedtest2"   
$resultsFilePath = "D:\speedtest2\Speedtest.csv"
$exeName = "speedtest.exe"
$exeParam = "-s"
$exeParam2 = "-f"
$exeParam3 = "csv"
$serverParam = "4087"   #server id
$header = '"date","time","server name","server id","idle latency","idle jitter","packet loss","download","upload","download bytes","upload bytes","share url","download server count","download latency","download latency jitter","download latency low","download latency high","upload latency","upload latency jitter","upload latency low","upload latency high","idle latency low","idle latency high"'

# Set the time interval in seconds
$timeInterval = 900  #15min

# Infinite loop
while ($true) {
    # Get the current date and time
	$currentDate = Get-Date -Format "dd.MM.yyyy"
	$currentTime = Get-Date -Format "HH:mm:ss"

    # Check if the results file already has a header
    if (!(Test-Path $resultsFilePath)) {
        # Create the results file and add the header
        Add-Content -Path $resultsFilePath -Value $header
    } else {
        # Check if the header is already present in the results file
        $resultsFileHeader = Get-Content $resultsFilePath -TotalCount 1
        if ($resultsFileHeader -ne $header) {
            # Add the header to the existing CSV file
            Add-Content -Path $resultsFilePath -Value $header 
        }
    }
    
    # run the program with the parameters
	Write-Output "Starte Messung ... "
    $output = & "$programPath\$exeName" $exeParam $serverParam $exeParam2 $exeParam3
	$outputWithQuotes = '"' + $currentDate + '","' + $currentTime + '",' + "$output"
    Add-Content -Path $resultsFilePath -Value $outputWithQuotes
	Write-Output "Fertig! Starte nchste Messung in $timeInterval s"
    
    # Wait for the specified time interval
    Start-Sleep -Seconds $timeInterval
}
